"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Utils = void 0;
class Utils {
    static getRequiredParamLength(constructor) {
        return constructor.length || 0;
    }
    static getMeta(key, ctr, def) {
        if (!Utils.isClass(ctr))
            return def;
        const meta = Reflect.getMetadata(key, ctr.prototype) || {};
        return meta[key] || def;
    }
    static logClass(ctr, missParamIndex) {
        var _a;
        const constructorArgs = Reflect.getMetadata("design:paramtypes", ctr) || [];
        const classStr = `${ctr.name}(${constructorArgs.map((arg, i) => {
            if (i === missParamIndex) {
                return "?";
            }
            return arg.name;
            // @ts-ignore
        }).join(", ")}) `;
        return classStr + (missParamIndex !== undefined ? `Please check the ${missParamIndex + 1}. param: ${(_a = constructorArgs[missParamIndex]) === null || _a === void 0 ? void 0 : _a.name}` : "");
    }
    static isPrimitiveCtr(ctr) {
        return ctr.name === "String" || ctr.name === "Number";
    }
}
exports.Utils = Utils;
Utils.isClass = (fn) => /^\s*class/.test(fn === null || fn === void 0 ? void 0 : fn.toString());
//# sourceMappingURL=Utils.js.map