"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddTags = void 0;
const Keys_1 = require("../Keys");
function AddTags(tags) {
    return (target) => {
        if (typeof tags === "string") {
            tags = [tags];
        }
        const metadata = Reflect.getMetadata(Keys_1.Keys.ADD_TAGS_KEY, target.prototype) || {};
        metadata[Keys_1.Keys.ADD_TAGS_KEY] = tags;
        Reflect.defineMetadata(Keys_1.Keys.ADD_TAGS_KEY, metadata, target.prototype);
    };
}
exports.AddTags = AddTags;
//# sourceMappingURL=AddTags.js.map