"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Inject = void 0;
require("reflect-metadata");
const Keys_1 = require("../Keys");
/*
* Save meta for constructor parameter or function parameter
* */
function Inject(propertyKey) {
    return (target, key, parameterIndex) => {
        var _a;
        const ctrOrTarget = key ? target.constructor : target;
        const metaKey = key ? key : Keys_1.Keys.INJECT_PROPERTY_DECORATOR_KEY;
        const reqParamCount = ((_a = target[key]) === null || _a === void 0 ? void 0 : _a.length) || (target === null || target === void 0 ? void 0 : target.length);
        const metadata = Reflect.getMetadata(metaKey, ctrOrTarget) || {};
        if (metadata[metaKey] === undefined) {
            metadata[metaKey] = [];
            metadata[Keys_1.Keys.IS_REQUIRED_PARAM] = [];
        }
        const param = { key: propertyKey, isRequired: (parameterIndex < reqParamCount), index: parameterIndex };
        // @ts-ignore
        metadata[metaKey][parameterIndex] = param;
        Reflect.defineMetadata(metaKey, metadata, ctrOrTarget);
    };
}
exports.Inject = Inject;
//# sourceMappingURL=Inject.js.map