"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectProperty = void 0;
const Keys_1 = require("../Keys");
function InjectProperty(key) {
    return function inject(target, propertyKey) {
        const ctr = target.constructor;
        const metadata = Reflect.getMetadata(Keys_1.Keys.PROPERTY_INJECT_KEY, ctr) || {};
        metadata[propertyKey] = key;
        Reflect.defineMetadata(Keys_1.Keys.PROPERTY_INJECT_KEY, metadata, ctr);
    };
}
exports.InjectProperty = InjectProperty;
//# sourceMappingURL=InjectProperty.js.map