"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Injectable = void 0;
const Keys_1 = require("../Keys");
function Injectable(options = { instantiation: "singleton" }) {
    return (target) => {
        const metadata = Reflect.getMetadata(Keys_1.Keys.INJECTABLE_KEY, target.prototype) || {};
        metadata[Keys_1.Keys.INJECTABLE_KEY] = options;
        Reflect.defineMetadata(Keys_1.Keys.INJECTABLE_KEY, metadata, target.prototype);
    };
}
exports.Injectable = Injectable;
//# sourceMappingURL=Injectable.js.map