"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MethodWrapper = void 0;
const Keys_1 = require("../Keys");
require("reflect-metadata");
function MethodWrapper(key) {
    return (target, propertyKey, descriptor) => {
        const metadata = Reflect.getMetadata(Keys_1.Keys.METHOD_WRAPPER_KEY, target.constructor) || {};
        // @ts-ignore
        metadata[propertyKey] = key;
        Reflect.defineMetadata(Keys_1.Keys.METHOD_WRAPPER_KEY, metadata, target.constructor);
        Reflect.defineMetadata(Keys_1.Keys.METHOD_DESCRIPTOR_KEY, Object.assign({}, descriptor), target.constructor);
    };
}
exports.MethodWrapper = MethodWrapper;
//# sourceMappingURL=MethodWrapper.js.map