"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RunBefore = void 0;
const Keys_1 = require("../Keys");
function RunBefore(key) {
    return (target, propertyKey, descriptor) => {
        const metadata = Reflect.getMetadata(Keys_1.Keys.BEFORE_METHOD_KEY, target.constructor) || {};
        // @ts-ignore
        metadata[propertyKey] = key;
        Reflect.defineMetadata(Keys_1.Keys.BEFORE_METHOD_KEY, metadata, target.constructor);
        Reflect.defineMetadata(Keys_1.Keys.METHOD_DESCRIPTOR_KEY, Object.assign({}, descriptor), target.constructor);
    };
}
exports.RunBefore = RunBefore;
//# sourceMappingURL=RunBefore.js.map