"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Setter = void 0;
const Keys_1 = require("../Keys");
function Setter() {
    return (target, propertyKey, descriptor) => {
        const metadata = Reflect.getMetadata(Keys_1.Keys.SETTER_METHOD_PROPERTY_DECORATOR_KEY, target.constructor) || {};
        if (metadata[Keys_1.Keys.SETTER_METHOD_PROPERTY_DECORATOR_KEY] === undefined) {
            metadata[Keys_1.Keys.SETTER_METHOD_PROPERTY_DECORATOR_KEY] = [];
        }
        metadata[Keys_1.Keys.SETTER_METHOD_PROPERTY_DECORATOR_KEY].push(propertyKey); // push setter methods.
        Reflect.defineMetadata(Keys_1.Keys.SETTER_METHOD_PROPERTY_DECORATOR_KEY, metadata, target.constructor);
    };
}
exports.Setter = Setter;
//# sourceMappingURL=Setter.js.map