import { IConstructorDefinition } from "./definitionInterfaces/IConstructorDefinition";
import { IInstantiatable } from "../interfaces/IInstantiatable";
import { IResolver } from "../interfaces/IResolver";
import { ArgResolver } from "./helpers/ArgResolver";
import { IInjectParamMeta } from "../decorators/Inject";
export declare class ConstructorInstantiation implements IInstantiatable {
    private readonly resolver;
    tags: string[];
    definition: IConstructorDefinition;
    argResolver: ArgResolver;
    constructor(definition: IConstructorDefinition, resolver: IResolver);
    instantiate(): Promise<any>;
    resolveParentArgs(ctr: any): Promise<any[]>;
    resolveArgsWithoutKey(ctr: any, args: IInjectParamMeta[] | any): Promise<any[]>;
    private isResolvable;
    private resolveConstructor;
}
